Multivariate Pattern Analysis in Python

### Navigation

- index
- modules |
- modules |
- PyMVPA Home |
- Sitemap »

# mvpa2.measures.base.Splitter

class `mvpa2.measures.base.``Splitter`(attr, attr_values=None, count=None, noslicing=False, reverse=False, ignore_values=None, **kwargs)

  Generator node for dataset splitting.

  The splitter is configured with the name of an attribute. When its `generate()` methods is called with a dataset, it subsequently yields all possible subsets of this dataset, by selecting all dataset samples/features corresponding to a particular attribute value, for all unique attribute values.

  Dataset splitting is possible by sample attribute, or by feature attribute. The maximum number of splits can be limited, and custom attribute values may be provided.

  Notes

  Available conditional attributes:

  - `calling_time+`: Time (in seconds) it took to call the node
  - `raw_results`: Computed results before invoking postproc. Stored only if postproc is not None.

  (Conditional attributes enabled by default suffixed with `+`)

  Methods

  `generate`(ds) | Yield dataset splits.
  `get_postproc`() | Returns the post-processing node or None.
  `get_space`() | Query the processing space name of this node.
  `reset`() |
  `set_postproc`(node) | Assigns a post-processing node Set to `None` to disable postprocessing.
  `set_space`(name) | Set the processing space name of this node.

  Parameters:

  attr : str

  > Typically the sample or feature attribute used to determine splits.

  attr_values : tuple

  > If not None, this is a list of value of the `attr` used to determine the splits. The order of values in this list defines the order of the resulting splits. It is possible to specify a particular value multiple times. All dataset samples with values that are not listed are going to be ignored.

  count : None or int

  > Desired number of generated splits. If None, all splits are output (default), otherwise the number of splits is limited to the given `count` or the maximum number of possible split (whatever is less).

  noslicing : bool

  > If True, dataset splitting is not done by slicing (causing shared data between source and split datasets) even if it would be possible. By default slicing is performed whenever possible to reduce the memory footprint.

  reverse : bool

  > If True, the order of datasets in the split is reversed, e.g. instead of (training, testing), (training, testing) will be spit out.

  ignore_values : tuple

  > If not None, this is a list of value of the `attr` the shall be ignored when determining the splits. This settings also affects any specified `attr_values`.

  enable_ca : None or list of str

  > Names of the conditional attributes which should be enabled in addition to the default ones

  disable_ca : None or list of str

  > Names of the conditional attributes which should be disabled

  space: str, optional :

  > Name of the ‘processing space’. The actual meaning of this argument heavily depends on the sub-class implementation. In general, this is a trigger that tells the node to compute and store information about the input data that is “interesting” in the context of the corresponding processing in the output dataset.

  postproc : Node instance, optional

  > Node to perform post-processing of results. This node is applied in `__call__()` to perform a final processing step on the to be result dataset. If None, nothing is done.

  descr : str

  > Description of the instance

  Methods

  `generate`(ds) | Yield dataset splits.
  `get_postproc`() | Returns the post-processing node or None.
  `get_space`() | Query the processing space name of this node.
  `reset`() |
  `set_postproc`(node) | Assigns a post-processing node Set to `None` to disable postprocessing.
  `set_space`(name) | Set the processing space name of this node.

  `generate`(ds)

    Yield dataset splits.

    Parameters:

    ds: Dataset :

    > Input dataset

    Returns:

    generator :

    > The generator yields every possible split according to the splitter configuration. All generated dataset have a boolean ‘lastsplit’ attribute in their dataset attribute collection indicating whether this particular dataset is the last one.

### Navigation

- index
- modules |
- modules |
- PyMVPA Home |
- Sitemap »